function f = BovSys_Equa(t, y, par,str,at,dm,mlk,c0)


%% Allocating state variables

    f=zeros(22,1);

    y_gnrhh= y(1);
    y_gnrh = y(2); 
    y_fshp = y(3);
    y_fsh  = y(4);
    y_lhp  = y(5);
    y_lh   = y(6);
    y_fol  = y(7);
    y_pg   = y(8);
    y_cl   = y(9);
    y_p4   = y(10);
    y_e2   = y(11);
    y_ih   = y(12);
    y_enz  = y(13);
    y_ot1  = y(14);
    y_iof  = y(15);
    y_igf_b= y(16);
    y_ins  = y(17);
    y_glu  = y(18);
    y_fat   = y(19);
    y_lv   = y(20);
    y_glu_st = y(21);
    y_gluca = y(22);
    
    
    
%% Interpolating data (DMI, Milk) 

%if str=='l'

    DMI  = interp1(at, dm, t);   % Interpolate the data set (at, dm) at times t
    Milk = interp1(at, mlk, t);  % Interpolate the data set (at, mlk) at times 

%elseif str=='n'
%    DMI  = 11700;   % Interpolate the data set (at, dm) at times t
%    Milk = 0;  % Interpolate the data set (at, mlk) at times 
%end
%%-----------------------------------------------------------------------------------------------------
%%--------------------------------------------Estrous Cycle Model-----------------------------------
%%-----------------------------------------------------------------------------------------------------


%% c
% c-----------------------------------------------------------------------
% c
% c Equation 1 and 2 : GnRH  
% c

    hm_e2_1 = par(4)^2 / ( par(4)^2 + y_e2^2 );
    hm_p4_1 = par(5)^2 / ( par(5)^2 + y_p4^2 );
    hm_p4_2 = par(6)*par(7)^2 / ( par(7)^2 + y_p4^2 );
    hp_e2_1 = par(8) * y_e2^5 / ( par(9)^5  +  y_e2^5 );

    gnrh_syn = par(2)*(1.0d0 - y_gnrhh/par(1)); 
    gnrh_rel = par(3)*(hm_p4_1 + hm_e2_1 - hm_e2_1*hm_p4_1) + hm_p4_2;

    f(1) =  gnrh_syn - gnrh_rel * y_gnrhh;
    f(2) =  gnrh_rel * y_gnrhh * hp_e2_1 - par(10) * y_gnrh;

%% c
% c-----------------------------------------------------------------------
% c
% c   Equation 3 and 4 : FSH
% c   

    efsh=2;
    hp_ins_FSH  = par(71)* (y_ins^efsh / (y_ins^efsh + par(72)^efsh));  % here we link metabolic to estrous cycle      

    hp_p4_1   = par(13) * y_p4^2     / ( par(14)^2 + y_p4^2 );
    hm_e2_2   = par(15) * par(16)^2  / ( par(16)^2 + y_e2^2 );
    hp_gnrh_1 = par(17) * y_gnrh^1   / ( par(18)^1 + y_gnrh^1 ) ;    

    fsh_syn = par(11) * par(12)^5 / (par(12)^5 + y_ih^5 );
    fsh_rel = ( par(20) + hp_p4_1 + hm_e2_2 + hp_gnrh_1 ) * y_fshp  ;
    
    f(3) =  fsh_syn*hp_ins_FSH - fsh_rel;  % here we link metabolic to estrous cycle
    f(4) =  fsh_rel - par(19) * y_fsh  ;
    

%% c
% c-----------------------------------------------------------------------
% c
% c Equation 5 and 6 : LH
% c
      elh=3;
      hp_ins_LH  = par(73)* (y_ins^elh / (y_ins^elh + par(74)^elh));   % here we link metabolic to estrous cycle
                    
      hp_e2_2   = par(21) * y_e2^2    / ( par(22)^2 + y_e2^2 );
      hm_p4_3   = par(23) * par(24)^2 / ( par(24)^2 + y_p4^2 );
      hp_gnrh_2 = par(25) * y_gnrh^5  / ( par(26)^5 + y_gnrh^5 );
      
      lh_syn =  (hp_e2_2 + hm_p4_3) ;
      lh_rel = (par(27) + hp_gnrh_2) *y_lhp;                                

      f(5) = lh_syn*hp_ins_LH - lh_rel;                 % here we link metabolic to estrous cycle                                   
      f(6) = lh_rel - par(28) * y_lh;                                         

%% c
% c-----------------------------------------------------------------------
% c
% c     Equation 7 : follicular size
% c

      hm_IGF = par(69)*(par(70)^2)/(par(70)^2+y_igf_b^2);   % here we link metabolic to estrous cycle
      hp_lh  = par(34) * y_lh^2 / ( hm_IGF^2 + y_lh^2) ;    % here we link metabolic to estrous cycle      
      hp_p4_2  = par(32) * y_p4^5 / (par(33)^5 + y_p4^5);
      hm_foll = (par(31)^2)/(par(31)^2+y(7)^2);
      hp_fsh_mod  = par(29) * y_fsh^2/ ((par(30)*hm_foll)^2+y_fsh^2);
     
      f(7) = hp_fsh_mod  - (hp_p4_2 +hp_lh) * y_fol;

      

%% c
% c-----------------------------------------------------------------------
% c     Equation 9 : corpus luteum
% c
      hp_cl_1 = par(41) * y_cl^30  / (  y_cl^30 + (par(42))^30 );
      
      hp_iof=par(43)*y_iof^5/(par(44)^5+y_iof^5);
      
      f(9) =  par(40)*hp_lh * y_fol + hp_cl_1 - hp_iof * y_cl;


%% c
% c-----------------------------------------------------------------------
% c
% c      Equation 10 :P4 rückgekoppelt

      f(10) =   par(47) + par(45)*y_cl^2 - par(46) * y_p4;
      

%% c      
% c-----------------------------------------------------------------------
% c
% c     Equation 8 : Prostaglandin F2alpha
% c
      hp_enz = par(36)*y_enz^1/(par(37)^1 + y_enz^1)   ;   
      hp_ot=y_ot1^10/(par(38)^10+y_ot1^10);
      
      f(8) =    hp_enz * hp_ot - par(39)*y(8);      
      
%% c
% c-----------------------------------------------------------------------
% c
% c      Equation 11 :Estradiol rückgekoppelt

      f(11) = par(48)*y_fol^2 - par(49)*y_e2;
      
%% c
% c-----------------------------------------------------------------------
% c
% c      Equation 12 : Inhibin rückgekoppelt

      f(12) = par(50)* y_fol^2  - par(51) * y_ih;
      
%% c
% c-----------------------------------------------------------------------
% c
% c     Equation 13 : enzymes for PG production
% c            
      hp_p4_3 = par(52) * y_p4^1 / ( par(53)^1 + y_p4^1 );

      f(13) = hp_p4_3 - par(54)*y_enz ;
          
%% c
% c-----------------------------------------------------------------------
% c
% c     Equation 14 : oxytocin 
% c        

      hp_e2_3 = par(55) * y_e2^2  / ( par(56)^2 + y_e2^2 );
     
      % Simulating lactating case with higher oxytocin profile as in the onset of postpartum period 
      
      if str == 'l' 
          
          % Term describing the oxytocin profile during postpartum

                input_oxt_L = par(58)*exp(-par(60)*(t)^2);
   
      % Simulating non-lactating case without oxytocin
      
      elseif str=='n'   
          
          % Term describing the oxytocin for lactating case. Hence we set
          % it to 0 since we are not in the lactating case
          
          input_oxt_L=0;
          
           
      end
          
          f(14) =   input_oxt_L + hp_e2_3 * y_cl^2 - par(57) * y_ot1;
          
  
      
%% c
% c---------------------------------------------------------------------
% c
% c     Equation 15: intra ovarian factors responsible for luteolysis
% c         
      hp_pg  = par(61) * y_pg^10 / ( y_pg^10 + par(62)^10 );
      hp_cl_3 = y_cl^1  / (  y_cl^1 + par(63)^1 );
      
      f(15) =   hp_pg * hp_cl_3 - par(64)*y_iof ;     

%% c
% c---------------------------------------------------------------------
% c
% c     Equation 16 and 17: Insulin-like growth Factor I  (IGF, IGFb)
% c

      egf=1;

      hp_glu_IGF   = par(75)*(y_ins.^egf / ( y_ins.^egf + par(76)^egf));   % here we link metabolic to estrous cycle

      hm_p4_3 = par(65)*par(66)^4/(par(66)^4+y_p4^4);
       
      f(16) = par(68) + hm_p4_3*hp_glu_IGF - par(67)*y_igf_b;              % here we link metabolic to estrous cycle
      
 
          
%%-----------------------------------------------------------------------------------------------------
%%--------------------------------------------Metabolic Model-----------------------------------
%%-----------------------------------------------------------------------------------------------------


%% Glucose extracted from DMI
%-------------------------------------------------------------------

        glu_pool = c0*DMI;
        
%% feeding ---> LIVER (processing glucoplastic substances)
%---------------------------------------------------------

        glu_feed_gng = (1 - par(77))*glu_pool;

%% feeding ---> BLOOD directely 
%------------------------------

        glu_feed_bl = par(77)*glu_pool;
        
%% Insulin secretion and degradation processes
%---------------------------------------------
        
        ins_sec = par(96)*(y_glu^10/(y_glu^10 + par(91)^10)); 
        
        ins_deg = par(97)*y_ins;
        
%% Glucagon secretion and degradation processes
 %----------------------------------------------
        
        gluca_sec = par(84)*(par(86)^2/(y_glu^2 + par(86)^2));
        
        gluca_deg =  par(85)*y_gluca;


%% Glucose production and storage in the liver
%---------------------------------------------

        glu_prod = par(87)*y_lv*y_gluca;
                    
        glu_bl_lv = par(88)*y_glu^10/(y_glu^10 + par(83)^10)*y_ins;

        glu_lv_st = par(82)*(1 - (y_glu_st/1000))*(par(81)^2/(par(81)^2 + Milk^2))*y_lv*y_ins;

        glu_st_lv = par(80)*y_gluca*(y_glu_st^10/(y_glu_st^10 + par(79)^10));
        
        glu_fat_lv = par(78)*((par(59)^10)/(y_glu_st^10 + par(59)^10))*(y_fat^1/(y_fat^1 + par(98)^1))*y_gluca;
        
        glu_lv_fat = par(35)*(par(89)^1/(par(89)^1 + Milk^1))*(y_glu_st^10/(y_glu_st^10 + par(90)^10))*y_lv*y_ins;
        
%% Glucose ultilization
%----------------------
        
        glu_bl_usage = par(93)*y_glu^10/(y_glu^10 + par(92)^10) + par(95)*Milk;  
        
        glu_lv_usage = par(94)*y_lv;        

%% Exchange between: BLOOD vs FAT
%---------------------------------------

        % 1 gram of fat = 9.3 Kcal
        % 1 gram of glucose = 4.1 Kcal

        fat_to_gl = 9.3/4.1;   % ratio fat to glucose
        gl_to_fat = 1/fat_to_gl;  % ratio glucose to fat


%-----------------------------------------------------------------------------------------------------
%--------------------------------------------Metabolic ODE--------------------------------------------
%-----------------------------------------------------------------------------------------------------

        V = 22.8;  % Extracellular volume of blood

%% ODE for Insulin:

        f(17) = ins_sec - ins_deg;

%% ODE for glucose in the blood

        f(18) =  (glu_feed_bl  + glu_prod - glu_bl_lv - glu_bl_usage)/V;          

%%  ODE for Fat:

        f(19) =    fat_to_gl*glu_lv_fat - glu_fat_lv;

%% ODE for Glucose change in the liver:

        f(20) = glu_feed_gng - glu_prod + glu_st_lv - glu_lv_st + gl_to_fat*glu_fat_lv - glu_lv_fat + glu_bl_lv - glu_lv_usage;        

%% ODE for Glucose in in the tissue:

        f(21) =  glu_lv_st - glu_st_lv;     
                       
        f(22) =  gluca_sec - gluca_deg;

%-----------------------------------------------------------------------------------------------------
%--------------------------------------------END--------------------------------------------
%-----------------------------------------------------------------------------------------------------





end
